;gran0.orc
	sr	=	22050
	kr	=	22050
	ksmps	=	1
	nchnls	=	1
	instr	1
iskip1	init 	0 
iskip2	init	0 
iamp	=	p4
ifrq	=	p5
ifrqrnd	=	p5/p11	;variazione random di frequenza
idur1	=	p6 	;durata iniziale dei grani
idur2	=	p7 	;durata finale dei grani
kdur	line	idur1, p3, idur2
iatkdec	=	p8	;tempo dattacco e di decay del grano (qualsiasi inviluppo 
				; del grano sar simmetrico)
idel1	=	p9	;delay iniziale
idel2	=	p10	;delay finale
kdel	expon	idel1+.001, p3, idel2+.001	;delay variabile
kfrqrnd	rand	ifrqrnd,-1		; generazione della variazione random di frequenza
tutto:
irand	=	i(kfrqrnd)	;trasformazione della componente random della frequenza da k a i
idur	=	i(kdur)		;trasformazione della durata dei grani da k a i
kenv1		linseg	0,iatkdec,iamp,idur-iatkdec*2,iamp,iatkdec,0,idur,0
			; allinviluppo del grano segue una pausa pari alla durata complessiva del grano
a1		oscili	kenv1, ifrq+irand, 1	; generazione del suono
idel	=	i(kdel)		;trasformazione dei valori di delay da k a i
		timout	0,idur+idel,contin		; queste istruzioni hanno lo scopo di...
							; ... "reinizializzare" linviluppo ogni idur+idel...
		reinit	tutto				; ...secondi, in modo da generare pi grani...
contin:						; ...allinterno di ogni nota (vedi par.17.3)
		rireturn
kenvt		linseg	0,.01,1,p3-.02,1,.01,0	; inviluppo complessivo della nota
		out	a1 * kenvt
		endin

