;scale.orc
sr = 22050
	kr = 2205
	ksmps = 10
	nchnls = 1

	instr	1
;innanzitutto dividiamo la parte intera (le ottave) dalla parte frazionaria di p5 
;(i semitoni)
ioct	=	int(p5)	;ottava=parte intera di p5
isem	=	frac(p5)*100	;semitono=parte decimale di p5, moltiplicata per 100
				;cos con 8.01 otteniamo 1, con 8.11 otteniamo 11 etc., e questi valori 
				;diventano gli indici della tabella, a cui 
				;corrisponderanno nuovi valori indicati nella funzione 2. 
				;In questo modo a ognuna delle vecchie note temperate 
				;sostituiremo lequivalente non equabile stabilendo 
				;i nuovi dodici valori nella funzione.
isem1		table		isem,2,0	;prende lindice,poi legge in 
					;tabella 2 il NUOVO valore del "semitono" senza riscalare. 
					;Dato che il III arg=0, lindice  "raw"=grezzo: con 
					;isem=0 leggo il primo valore, con isem =1 leggo il
					;secondo valore, con isem =3 leggo il quarto valore etc.
ifrq	=	cpspch(ioct+isem1) 	;converte il valore ottava+"semitono" in Hertz
iamp	=	ampdb(p4)
a1	oscili	iamp, ifrq, 1
	out	a1
	endin

	instr	2
;uso di table per costruzione di scale non equabili, con interpolazione
ioct	=	int(p5)		;ottava=parte intera di p5
isem	=	frac(p5)*100		;semitono=parte decimale di p5, moltiplicato per 100 
					;cos otteniamo per 8.01->1, per 8.11->11 etc.
isem1	tablei	isem, 2, 0		;come instr 1, ma con tabella a interpolazione, che
					;permette anche che isem1 sia NON INTERO.
ifrq	=	cpspch(ioct+isem1) 	;converte il valore ottava+"semitono" in Hertz
iamp	=	ampdb(p4)		;converte i dB in ampiezza assoluta
a1	oscil	iamp, ifrq, 1
	out	a1
	endin
 
