;scalacr.orc
	sr	=	44100
	kr	=	4410
	ksmps	=	10
	nchnls	=	1
	instr	1
iamp		=	ampdb(p4)
ipitch		=	p5						;pitch di partenza
ioctst		=	int(p5)					;ottava di partenza
ioctend	=	int(p6) 					;ottava di arrivo
isemist	=	frac(p5)*100					;semitono di partenza
isemiend	=	frac(p6)*100					;semitono di arrivo
isemirng	=	(ioctend-ioctst)*12+(isemiend-isemist)+1	;semitoni da suonare
idur		=	p3/isemirng					;durata di ogni semitono
daqua:
ifrq		=	cpspch(ipitch) 				;conversione da pitch a Hz
kenv		linseg	0,.01,iamp,idur-.01,0			;inviluppo di ogni semitono
		timout	0,idur,continua				;reinizializzare ogni idur secondi
ipitch		=	ipitch+.01					;incremento di ipitch per suonare il 
									;semitonosuccessivo
		reinit	daqua
continua:
		rireturn
a1		oscili	kenv,ifrq,1					;generazione del suono
		out	a1
		endin
 
